#!/bin/sh
#
# Copyright (c) 2007, 2008  Peter Pentchev
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Ringlet: trivbackup.sh 1785 2008-01-31 12:58:32Z roam $

# TODO: Parse the command-line options (-h, -V, -f conffile)

# Read the config file
CONFFILE='/etc/trivbackup.conf'
if [ ! -r "${CONFFILE}" ]; then
	echo "Unable to read configuration file $CONFFILE" 1>&2
	exit 1
fi

. "${CONFFILE}"

# Let's rock!

removeold=1

# Backup the web structure if requested
if [ -n "$WEBBACKUPDIR" ]; then
	trivbackup_dirtree "$WEBDIR" "$WEBBACKUPDIR" || removeold=0
fi

# Backup the MySQL databases if requested
if [ -n "$MYSQLBACKUPDIR" ]; then
	trivbackup_mysql "$MYSQLBACKUPDIR" || removeold=0
fi

# Remove the old backups if no errors occurred
if [ "$removeold" = '1' ]; then
	trivbackup_removeold "$BACKUPDIR"
else
	echo "Errors encountered, not removing old backups." 1>&2
fi
